'''
Created on 2011-03-25

@author: eposse
'''

import unittest

from libutilitaspy.data_structures.maps import Map

class Test(unittest.TestCase):


    def setUp(self):
        pass


    def tearDown(self):
        pass


    def test_mutable_maps(self):
        m1 = Map({1: 'a', 2: 'b', 3: 'a'})
        m2 = Map(lambda x: 'a' if x in (1,3) else 'b')
        m3 = Map([(1,'a'), (3,'a'), (2,'b')]) 
        y1 = m1[3]
        y2 = m1(3)
        self.assertEquals(y1, 'a')
        self.assertEquals(y2, 'a')
        self.assertEquals(y1, y2)
        y3 = m2[1]
        y4 = m3(1)
        self.assertEquals(y3, y4)
        m1[5] = 'c'
        y5 = m1(2)
        y6 = m1(5)
        self.assertEquals(y5, 'b')
        self.assertEquals(y6, 'c')
        m2[7] = 'd'
        y7 = m2(2)
        y8 = m2(7)
        self.assertEquals(y7, 'b')
        self.assertEquals(y8, 'd')
        m2[8] = 'e'
        y9 = m2(7)
        y10 = m2(8)
        y11 = m2(2)
        self.assertEquals(y9, 'd')
        self.assertEquals(y10, 'e')
        self.assertEquals(y11, 'b')
        m2[2] = 'f'
        y12 = m2(7)
        y13 = m2(8)
        y14 = m2(2)
        self.assertEquals(y12, 'd')
        self.assertEquals(y13, 'e')
        self.assertEquals(y14, 'f')


if __name__ == "__main__":
    #import sys;sys.argv = ['', 'Test.test_mutable_maps']
    unittest.main()